/*

							Board Generator

*/

#include <stdio.h>
#include <conio.h>
#include <graphics.h>

FILE *f;

int Grid[12][24];

#define	BIT_DOWN	(0x01)
#define BIT_UP		(0x02)
#define BIT_LEFT	(0x04)
#define BIT_RIGHT	(0x08)
#define BIT_FILLED	(0x20)
#define BIT_DOT		(0xC0)

void Box(int x1,int y1,int x2,int y2)
{
	int x,y,n;
	for (x = x1;x <= x2;x++)
	{
		n = BIT_LEFT+BIT_RIGHT;
		if (x == x2) n = BIT_LEFT;
		if (x == x1) n = BIT_RIGHT;
		Grid[x][y1] |= n;
		Grid[x][y2] |= n;
	}

	fprintf(f,";\n;     Box at (%d,%d) to (%d,%d)\n;\n",x1,y1,x2,y2);
	fprintf(f,"    .db    %03d+%03d+4,0\n",
					(y2-y1)*2+(x2-x1)*2,(y2-y1-1)*(x2-x1-1));
	fprintf(f,"    .db    ");
	for (y = y1+1;y < y2;y++)
	{
		Grid[x1][y] |= BIT_DOT;
		Grid[x2][y] |= BIT_DOT;
		fprintf(f,"%03d,%03d,",x1+y*10,x2+y*10);
	}

	for (x = x1;x <= x2;x++)
	{
		Grid[x][y1] |= BIT_DOT;
		Grid[x][y2] |= BIT_DOT;
		fprintf(f,"%03d,%03d,",x+y1*10,x+y2*10);
	}
	fprintf(f,"255\n");
	fprintf(f,"    .db    ");
	for (x = x1+1;x < x2;x++)
		for (y = y1+1;y < y2;y++)
			{
			fprintf(f,"%03d,",x+y*10);
			}
	fprintf(f,"255\n");

}

void main()
{
	int	Driver = VGA,Mode = VGALO;
	int xc,yc,x,y,w,h,n;
	initgraph(&Driver,&Mode,".");
	f = fopen("BOARD.INC","w");
	for (x = 0;x < 10;x++)
		for (y = 0;y < 24;y++)
			{
			Grid[x][y] = 0x00;
			n = BIT_UP+BIT_DOWN;
			if (y == 0) n = BIT_DOWN;
			if (y == 23) n = BIT_UP;
			if (x % 3 == 0) Grid[x][y] = n;
			}

	fprintf(f,"Boxes:\n");
	Box(0,0,3,4);
	Box(0,4,3,9);
	Box(0,9,3,12);
	Box(0,12,3,16);
	Box(0,16,3,19);
	Box(0,19,3,23);

	Box(3,0,6,3);
	Box(3,3,6,7);
	Box(3,7,6,10);
	Box(3,10,6,13);
	Box(3,13,6,15);
	Box(3,15,6,18);
	Box(3,18,6,21);
	Box(3,21,6,23);

	Box(6,0,9,2);
	Box(6,2,9,5);
	Box(6,5,9,9);
	Box(6,9,9,12);
	Box(6,12,9,14);
	Box(6,14,9,17);
	Box(6,17,9,20);
	Box(6,20,9,23);

	fprintf(f,"    .db    0,0\n\n");

	w = 20;h = 8;
	for (x = 0;x < 10;x++)
		for (y = 0;y < 24;y++)
		{
			n = Grid[x][y];
			if (n == 0) n = BIT_FILLED;
			setcolor(YELLOW);
			xc = x*w+w/2;yc = y*h+h/2;
			if (n & BIT_DOWN) 	line(xc,yc,xc,yc+h/2);
			if (n & BIT_UP) 	line(xc,yc,xc,yc-h/2);
			if (n & BIT_LEFT) 	line(xc,yc,xc-w/2,yc);
			if (n & BIT_RIGHT) 	line(xc,yc,xc+w/2,yc);
			if (n & BIT_FILLED)
			{
				setfillstyle(WIDE_DOT_FILL,GREEN);
				setcolor(GREEN);
				bar(x*w,y*h,x*w+w,y*h+h);
			}
			if (n & BIT_DOT)
			{
				setcolor(RED);
				setfillstyle(SOLID_FILL,RED);
				fillellipse(xc,yc,w/5,h/5);
			}
		}

	fprintf(f,"    .org ((*+255)/256)*256\n");
	fprintf(f,"Board:\n");
	for (y = 0;y < 24;y++)
	{
		fprintf(f,"    .db    ");
		for (x = 0;x < 10;x++)
			fprintf(f,"$%02x%s",Grid[x][y],(x < 9) ? ",":"\n");
	}
	getch();
	closegraph();
	fclose(f);
}